﻿
#include <windows.h>
#include <tchar.h>
#include "pch.h"
#include <math.h>

HDC   g_hBackDC = NULL;
HBITMAP   g_hBackBMP = NULL;
SIZE g_ClientSize;		//	윈도우 창의 크기를 저장할 변수

float x2 = 400.f;         //	원의 중심 x좌표
float y2 = 500.f;         //	원의 중심 y좌표
float diameter = 20.f;	//	원의 지름

double Distance = 0.f;	//	원의 중심과 직선의 거리

float StartX = 250.f;	//	직선의 시작점의 x좌표
float StartY = 450.f;	//	직선의 시작점의 y좌표
float EndX = 590.f;		//	직선의 끝점의 x좌표
float EndY = 110.f;		//	직선의 끝점의 y좌표

//	점과 직선을 그리는 함수
void Draw(HDC _hDC)
{
	//	원을 그린다.
	Ellipse(_hDC, (int)x2, (int)y2, (int)(x2 + diameter), (int)(y2 + diameter));

	//	직선의 시작점과 끝점을 긋는다.
	MoveToEx(_hDC, (int)StartX, (int)StartY, NULL);
	LineTo(_hDC, (int)EndX, (int)EndY);

	//	앞에서 구한 직선과 점의 거리를 출력한다.
	TCHAR test[256] = { 0, };

	_stprintf_s(test, L"거리 : %.1f", fabs(Distance));
	TextOut(_hDC, 400, 350, test, lstrlen(test));
}

//	점을 움직이는 함수(유저가 입력한 키보드에 의해 이동)
void Action(void)
{
	if (GetAsyncKeyState(VK_RIGHT)) x2 += 0.2f;
	if (GetAsyncKeyState(VK_LEFT)) x2 -= 0.2f;
	if (GetAsyncKeyState(VK_UP)) y2 -= 0.2f;
	if (GetAsyncKeyState(VK_DOWN)) y2 += 0.2f;
}

//	점과 직선의 거리를 구하는 함수
void FindDistance(HWND hWnd)
{
	//	직선의 방정식은 y = ax + r 로 쓰자.

	float a = 0.f;		//	직선의 기울기
	float r = 0.f;

	//	먼저 a와 r을 구하자. a는 직선의 기울기
	//	1. 직선의 기울기를 먼저 구하자.
	a = (EndY - StartY) / (EndX - StartX);

	//	2. r을 구하자.
	//	r = y - ax 에서, 점(StartX, StartY)과 점(EndX , EndY)에서 둘 중에 하나를 대입한다.
	//	r = y - ax = StartY - a*StartX
	r = StartY - a * StartX;

	Distance = fabs(((double)a * x2 - y2 + r)) / sqrtf(a * a + 1);
}

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR strCmdLine, int nShowCmd)
{
	WNDCLASSEX wcex;		
	memset(&wcex, 0, sizeof(wcex));	

	wcex.cbSize = sizeof(wcex);		
	wcex.style = CS_HREDRAW | CS_VREDRAW;	
	wcex.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);	
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);					
	wcex.hIcon = LoadIcon(NULL, IDI_APPLICATION);				
	wcex.hInstance = hInstance;			
	wcex.cbClsExtra = 0;				
	wcex.cbWndExtra = 0;				
	wcex.hIconSm = NULL;				
	wcex.lpszMenuName = NULL;			
	wcex.lpfnWndProc = WndProc;			

	wcex.lpszClassName = L"MyWindow";	
	RegisterClassEx(&wcex);				

	HWND hWnd = CreateWindow(L"MyWindow", L"MyWindow", WS_OVERLAPPEDWINDOW,		
		CW_USEDEFAULT, CW_USEDEFAULT, 800, 600, NULL, NULL, hInstance, NULL);

	if (hWnd == NULL)
	{
		MessageBox(NULL, L"윈도우 생성 실패", L"에러", MB_ICONERROR | MB_OK);
		return -1;
	}

	ShowWindow(hWnd, SW_SHOW);

	MSG msg;
	memset(&msg, 0, sizeof(msg));

	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

		Action();
		FindDistance(hWnd);
		InvalidateRect(hWnd, NULL, false);
	}

	return 0;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
	{
		RECT rc;
		GetClientRect(hWnd, &rc);
		g_ClientSize.cx = rc.right - rc.left;
		g_ClientSize.cy = rc.bottom - rc.top;
		HDC hdC = GetDC(hWnd);
		g_hBackDC = CreateCompatibleDC(hdC);
		g_hBackBMP = CreateCompatibleBitmap(hdC, g_ClientSize.cx, g_ClientSize.cy);
		SelectObject(g_hBackDC, g_hBackBMP);
		break;
	}
	case WM_PAINT:
	{
		PAINTSTRUCT ps;
		HDC hDC = BeginPaint(hWnd, &ps);
		BitBlt(hDC, 0, 0, g_ClientSize.cx, g_ClientSize.cy, g_hBackDC, 0, 0, NOTSRCCOPY);
		Draw(hDC);

		EndPaint(hWnd, &ps);
		break;
	}
	case WM_DESTROY:	
	{
		DeleteDC(g_hBackDC);
		DeleteObject(g_hBackBMP);

		PostQuitMessage(0);
		break;
	}
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}